<template>
  <div>
    <el-card class="el-card">
      <el-form :model="listQuery" label-width="120px" v-if="showSearch">
        <el-row>
          <el-col :span="18">
            <el-form-item label="UDI码:" class="query-form-item">
              <el-input v-model="listQuery.udiCode" style="width: 96%" placeholder="请扫描或输入UDI码" clearable="true"
                        @keyup.enter.native="keyup_submit($event)"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="6">
            <el-form-item label="拼音简写:" class="query-form-item">
              <el-input v-model="listQuery.pinyinInitial" @input="search" style="width: 100%" placeholder="请输入物资拼音简写"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="第三方物资编码:" class="query-form-item">
              <el-input v-model="listQuery.thrPiId" style="width: 100%" placeholder="第三方物资编码"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="分类编码:" class="query-form-item">
              <el-input v-model="listQuery.flbm" style="width: 100%" placeholder="请输入分类编码"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="供应商:" class="query-form-item">
              <el-input v-model="listQuery.companyName" style="width: 100%" placeholder="请输入供应商"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="6">
            <el-form-item label="DI/物资编码:" class="query-form-item">
              <el-input v-model="listQuery.unionCode" style="width: 100%" placeholder="请输入DI/医保编码/商品条码"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="物资名称:" class="query-form-item">
              <el-input v-model="listQuery.cpmctymc" style="width: 100%" placeholder="请输入物资名称"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="规格型号:" class="query-form-item">
              <el-input v-model="listQuery.ggxh" style="width: 100%" placeholder="请输入规格型号" clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="生产企业:" class="query-form-item">
              <el-input v-model="listQuery.manufactory" style="width: 100%" placeholder="请输入生产企业/注册备案人"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="6">
            <el-form-item label="物资分类:" class="query-form-item">
              <el-input v-model="listQuery.category" style="width: 100%" placeholder="请输入物资分类名称"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6" v-if="productRemarkSet.remarkEnable1">
            <el-form-item :label="productRemarkSet.remarkTitle1+':'" class="query-form-item">
              <el-input v-model="listQuery.basicPrductRemak1" style="width: 100%"
                        :placeholder="productRemarkSet.remarkTitle1"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6" v-if="productRemarkSet.remarkEnable2">
            <el-form-item :label="productRemarkSet.remarkTitle2 +':'" class="query-form-item">
              <el-input v-model="listQuery.basicPrductRemak2" style="width: 100%"
                        :placeholder="productRemarkSet.remarkTitle2"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div class="top-right-btn">
        <el-button-group style="display:flex;">
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button type="primary" icon="el-icon-refresh" @click="onReset">重置</el-button>
          <el-button type="primary" icon="el-icon-search" @click="search">查询</el-button>
          <el-button type="primary" icon="el-icon-plus" @click="confirmSelect">确定</el-button>
        </el-button-group>
      </div>
      <el-divider style="margin: 15px"></el-divider>

      <el-table :data="dataList" style="width: 100%" v-loading="loading" border highlight-current-row
                :row-class-name="tableRowClassName" @current-change="handleChange" :row-key="row=>row.id"
                @selection-change="handleSelectionChange" ref="multipleTable">
        <el-table-column type="selection" :reserve-selection="true"></el-table-column>
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="最小销售产品标识" prop="nameCode" width="140" show-overflow-tooltip></el-table-column>
        <el-table-column label="第三方物资编码" prop="thirdId" width="120" show-overflow-tooltip></el-table-column>
        <el-table-column label="物资名称" prop="cpmctymc" width="160" show-overflow-tooltip></el-table-column>
        <el-table-column label="商品名称" prop="spmc" width="160" show-overflow-tooltip></el-table-column>
        <el-table-column label="规格型号" prop="ggxh" width="140" show-overflow-tooltip></el-table-column>
        <el-table-column label="包装规格" prop="bzgg" width="140" show-overflow-tooltip></el-table-column>
        <el-table-column label="注册/备案凭证" prop="zczbhhzbapzbh" width="160" show-overflow-tooltip></el-table-column>
        <el-table-column label="医疗器械注册人" width="160" prop="ylqxzcrbarmc"></el-table-column>
        <el-table-column label="器械类别" prop="qxlb" width="100" show-overflow-tooltip></el-table-column>
        <el-table-column label="供应商" prop="companyName" width="160" show-overflow-tooltip></el-table-column>
        <el-table-column
          v-if="productRemarkSet.remarkEnable1"
          :label="productRemarkSet.remarkTitle1" prop="basicPrductRemak1" width="140"
          show-overflow-tooltip></el-table-column>
        <el-table-column
          v-if="productRemarkSet.remarkEnable2"
          :label="productRemarkSet.remarkTitle2" prop="basicPrductRemak2" width="140"
          show-overflow-tooltip></el-table-column>
        <el-table-column
          v-if="productRemarkSet.remarkEnable3"
          :label="productRemarkSet.remarkTitle3" prop="basicPrductRemak3" width="140"
          show-overflow-tooltip></el-table-column>
        <el-table-column
          v-if="productRemarkSet.remarkEnable4"
          :label="productRemarkSet.remarkTitle4" prop="basicPrductRemak4" width="140"
          show-overflow-tooltip></el-table-column>
        <el-table-column label="操作" width="80" fixed="right">
          <template slot-scope="scope">
            <el-button type="text" size="small" @click.native.stop="handleDetailClick(scope.row)">详情</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="pageTotal>0"
        :total="pageTotal"
        :page.sync="listQuery.page"
        :limit.sync="listQuery.limit"
        @pagination="handleErpPageChange"

      ></pagination>
    </el-card>

    <el-dialog
      title="耗材字典详情"
      :visible.sync="udiRlDetailVisible"
      width="80%"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      append-to-body
      v-if="udiRlDetailVisible"
    >
      <udiRlDetailDialog :editQuery="currentRow"></udiRlDetailDialog>
    </el-dialog>

    <el-dialog title="请选择对应的注册/备案证" :visible.sync="dialogFormVisible" append-to-body width="40%">
      <el-form :model="form">
        <el-form-item label="" prop="isGive">
          <el-radio-group v-model="currentCert">
            <el-radio style="width: 100%;  margin-top: 10px;" :label="item" :key="item" v-for="item in certList">{{
                item
              }}
            </el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="selectCert">确 定</el-button>
        <el-button @click="dialogFormVisible = false">取 消</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import {
  filterCompanyProductplanRelevance,
  filterCompanyProductRationRelevance,
  filterCompanyProductRelevance
} from "../../../api/basic/udiRlSuptRelevance";
import {addApplyDetail, addApply} from "../../../api/purchase/purApply";
import store from "../../../store";
import udiRlDetailDialog from "./../../purchase/purApply/purUdiRlDetailDialog";
import {finProductSet} from "@/api/param/systemParamConfig";
import {addSet} from "@/api/system/InvRationSet";

export default {
  name: "stockOrderNewSelectProduct",
  props: {
    data: {
      type: Object,
      required: true,
    },
    closeDialog: {
      type: Function,
      required: true,
    },
    purType: {
      type: Object,
      required: true,
    },
    pId: {
      type: Object,
      required: true,
    },
    codeArray: {
      type: Object,
      required: true,
    },
    listType: {     //null:申购单产品选入；1：定量设置产品选入；2：设备入库产品选入
      type: Object,
      required: true,
    },
    invCode: {
      type: Object,
      required: true,
    },
    attributeType: {
      type: Object,
      required: true,
    },
    chooseFunc: {
      required: false, type: Function
    }
  },

  data() {
    return {
      showSearch: true,
      listQuery: {
        purType: null,
        udiCode: null,
        unicode: null,
        cpmctymc: null,
        ggxh: null,
        ylqxzcrbarmc: null,
        thrPiId: null,
        pinyinInitial: null,
        attributeType: null,
        page: 1,
        limit: 10,
      },
      combineQuery: {
        thirdId: "",
        relId: "",
        erpName: "",
        keys: [],
      },
      ids: [],
      lists: [],
      radioCheck: null,
      dataList: [],
      pageTotal: 1,
      total: 1,
      currentRow: null,
      loading: false,
      udiRlDetailVisible: false,
      thirdSys: [],
      thirdSysFk: null,
      busTypes: [],
      actDateRange: [],
      tQuery: {
        productId: "",
        productName: "",
        count: "",
        orderIdFk: "",
        supId: "",
      },
      productRemarkSet: {},
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      orderEditor: false,
      orderId: "",
      currentCert: null,
      certList: [],
      dialogFormVisible: false,
      multipleSelection: null,
    };
  },
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.listQuery = {
        purType: null,
        udiCode: null,
        unicode: null,
        cpmctymc: null,
        ggxh: null,
        ylqxzcrbarmc: null,
        thrPiId: null,
        page: 1,
        limit: 10
      }
      this.multipleSelection = [];
      this.radioCheck = null;
      this.currentRow = null;
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    tableRowClassName({row}) {
      if (row.checked) return "warning-row";
      return "";
    },
    checkSelectable(row) {
      return !row.check;
    },
    handleCurrentChange(val) {
      this.unionQuery.page = val;
      this.getList();
    },
    handleChange(val) {
      this.radioCheck = val.id;
      this.currentRow = val;
      this.multipleSelection = val
    },
    handleDetailClick(row) {
      this.currentRow = row;
      this.udiRlDetailVisible = true;

    },
    handleErpPageChange(val) {
      this.listQuery.page = val.page;
      this.getList();
    },
    keyup_submit(event) {
      this.listQuery.page = 1;
      this.getList();
      event.target.select();
    },
    search() {
      this.listQuery.page = 1;
      this.getList();
    },
    getList() {
      this.listQuery.attributeType = this.attributeType
      if (this.listType == null)
        this.getApplyList();
      else {
        this.getRationList();
      }
    },


    getApplyList() {
      this.loading = true;
      this.listQuery.customerId = store.getters.customerId;
      this.listQuery.id = this.pId;
      filterCompanyProductplanRelevance(this.listQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.dataList = response.data.list || [];
            this.pageTotal = response.data.total || 0;
          } else {
            this.$message.error(response.message);
            this.dataList = [];
            this.pageTotal = 0;
          }
        })
        .catch(() => {
          this.loading = false;
          this.dataList = [];
          this.pageTotal = 0;
        });
    },

    getRationList() {
      this.loading = true;
      filterCompanyProductRationRelevance(this.listQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.dataList = response.data.list || [];
            this.pageTotal = response.data.total || 0;
          } else {
            this.$message.error(response.message);
            this.dataList = [];
            this.pageTotal = 0;
          }
        })
        .catch(() => {
          this.loading = false;
          this.dataList = [];
          this.pageTotal = 0;
        });
    },
    intentBack() {
      this.closeDialog();
    },
    handleSelectionChange(val) {

      if (this.listType != 2) {
        this.lists = [];
        for (var i = 0; i < val.length; i++) {
          this.tQuery = {}
          this.tQuery.productId = val[i].id;
          this.tQuery.supId = val[i].customerId;
          this.tQuery.productName = val[i].cpmctymc;
          this.tQuery.count = 1;
          this.tQuery.orderIdFk = this.pId;
          this.tQuery.zczbhhzbapzbh = val[i].zczbhhzbapzbh;
          this.tQuery.measname = val[i].measname;
          this.lists.push(this.tQuery)
        }
      } else {
        this.lists = []
        this.lists = val;
      }

      console.log(this.lists)
    },

    confirmSelect() {
      if (this.lists == null) {
        this.$message.error('未选择产品');
        return;
      }
      if (this.listType == null) {
        this.puApplayAdd();
      } else if (this.listType == 1) {
        this.invRationAdd();
      } else if (this.listType == 2) {
        this.deviceAdd();
      }
    },

    puApplayAdd() {
      this.loading = true;
      addApplyDetail(this.lists).then((response) => {
        this.loading = false;
        if (response.code === 20000) {
          this.closeDialog(response.data);
        } else {
          if (response.code == 601) {
            this.$alert(response.message, "提示", {
              confirmButtonText: "确定",
            });
          } else
            this.$message.error(response.message);
        }
      }).catch(() => {
        this.loading = false;
      });

    },

    invRationAdd() {
      this.loading = true;
      let datas = [];
      this.lists.forEach((item) => {
        let dataItem = {
          relId: item.productId,
          supId: item.supId,
          curInvCode: this.invCode,
        }
        datas.push(dataItem);
      });
      let query = {
        rationEntities: datas
      }
      addSet(query).then((response) => {
        this.loading = false;
        if (response.code === 20000) {
          this.closeDialog(response.data);
        } else {
          if (response.code == 601) {
            this.$alert(response.message, "提示", {
              confirmButtonText: "确定",
            });
          } else
            this.$message.error(response.message);
        }
      }).catch(() => {
        this.loading = false;
      });

    },


    deviceAdd() {
      this.chooseFunc(this.lists)
    },


    selectCert() {
      if (this.currentCert == null) {
        this.$message.error("请先选择对应的注册证！");
      } else {
        this.multipleSelection.zczbhhzbapzbh = this.currentCert;
        this.combine();
      }
    },
    findBasicProductSet() {
      finProductSet().then((response) => {
        if (response.code == 20000) {
          this.productRemarkSet = response.data;
        }
      });
    },
  },
  components: {udiRlDetailDialog},

  created() {
    this.findBasicProductSet();
    this.listQuery.attributeType = this.attributeType
    if (this.$isNotBlank(this.data)) {
      this.ids = [];
      if (this.data.stockOrderLists.length > 0) {
        for (var i = 0; i < this.data.stockOrderLists.length; i++) {
          this.ids.push(this.data.stockOrderLists[i].productId);
        }
      }
    }
    this.listQuery.page = 1;
    this.getList();
  },
};
</script>

<style scoped>

.query-form-item {
  margin-right: 5px;
  margin-bottom: 5px;
}

div /deep/ .el-table .warning-row {
  background: #bebebe;
}

div /deep/ .el-table .success-row {
  background: #ffffff;
}
</style>
